package net.argius.frui.operation;

import java.io.*;
import java.util.*;

import net.argius.frui.*;

/**
 * gqZbgo͏B
 */
public class PrintSuffixSet extends Print {

    private final Set set;

    /**
     * PrintSuffixSet̐B
     */
    public PrintSuffixSet() {
        this.set = new HashSet();
    }

    /* (overridden)
     * @see net.argius.frui.operation.Print#printInfo(net.argius.frui.FileInfo)
     */
    protected void printInfo(FileInfo fileInfo) throws IOException {
        File file = fileInfo.getFile();
        if (file.isDirectory()) {
            return;
        }
        String suffix = getSuffix(file.getName());
        if (!set.contains(suffix)) {
            set.add(suffix);
            println(suffix);
        }
    }

    /**
     * gqԂB
     * @param fileName t@C
     * @return gq(sIhȂ) gqꍇ"(no-suffix)"
     */
    private static String getSuffix(String fileName) {
        int index = fileName.lastIndexOf('.');
        if (index >= 0) {
            return fileName.substring(index + 1);
        } else {
            return ".";
        }
    }

}
